﻿Public Class MainForm

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        comboPort.Items.AddRange(System.IO.Ports.SerialPort.GetPortNames())
        comboPort.SelectedIndex = 0

        comboBaudrate.SelectedIndex = 0    ' 115200 baud
        comboIrda.SelectedIndex = 1        ' litelink Irda adapter
        comboComType.SelectedIndex = 0     ' Continuous
        numericSuccessNoAnswer.Enabled = False

        buttonStopProtocol.Enabled = False
    End Sub

    Private Sub comboComType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboComType.SelectedIndexChanged
        If (comboComType.SelectedIndex = 0) Then
            numericSuccessNoAnswer.Enabled = False
        Else
            numericSuccessNoAnswer.Enabled = True
        End If
    End Sub

    Private Sub buttonStartProtocol_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonStartProtocol.Click
        If (OseComm1.IsProtocolRunning) Then
            Return
        End If

        Dim port As String = comboPort.SelectedItem.ToString()
        OseComm1.COMport = Convert.ToInt16(port.Substring(3))
        OseComm1.Baudrate = Convert.ToInt32(comboBaudrate.SelectedItem.ToString())
        OseComm1.IrdaAdapter = comboIrda.SelectedIndex

        ' Start the OseComm protocol
        If (OseComm1.StartProtocol(comboComType.SelectedIndex, numericSuccessNoAnswer.Value)) Then
            buttonStopProtocol.Enabled = True
            buttonStartProtocol.Enabled = False

            comboPort.Enabled = False
            comboBaudrate.Enabled = False
            comboIrda.Enabled = False
            comboComType.Enabled = False
            numericSuccessNoAnswer.Enabled = False
        End If
    End Sub

    Private Sub buttonStopProtocol_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonStopProtocol.Click
        ' If (OseComm1.IsProtocolRunning) Then
        ' Stop the OseComm Protocol
        OseComm1.StopProtocol()
        progressFileTransfer.Value = 0

        buttonStopProtocol.Enabled = False
        buttonStartProtocol.Enabled = True

        comboPort.Enabled = True
        comboBaudrate.Enabled = True
        comboIrda.Enabled = True
        comboComType.Enabled = True
        If (comboComType.SelectedIndex <> 0) Then
            numericSuccessNoAnswer.Enabled = True
        End If
        ' End If
    End Sub

    Private Sub buttonGetTimeDate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonGetTimeDate.Click
        If (OseComm1.AddGetTerminalTimeDate(OseComm.TimeDateFmt.FmthhmmssDDMMYYYYY)) Then
            listOptions.Items.Add("Get Time Date")
        End If
    End Sub

    Private Sub buttonSetTimeDate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSetTimeDate.Click
        OseComm1.AddSetLocalTimeDate()
        listOptions.Items.Add("Set Time Date")
    End Sub

    Private Sub buttonClearOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonClearOptions.Click
        OseComm1.ClearProtocolTaskList()
        listOptions.Items.Clear()
    End Sub

    Private Sub buttonGetOsVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonGetOsVersion.Click
        OseComm1.AddGetTerminalOSVersion()
        listOptions.Items.Add("Get OS Version")
    End Sub

    Private Sub buttonGetAppVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonGetAppVersion.Click
        OseComm1.AddGetTerminalApplicationVersion()
        listOptions.Items.Add("Get Application version")
    End Sub

    Private Sub buttonTerminalToPC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonTerminalToPC.Click
        Dim Form As FileForm = New FileForm
        Form.FormText = "Send File From Terminal to PC"
        Form.UseDownType = True
        If (Form.ShowDialog() = DialogResult.OK) Then
            if (oseComm1.AddReceiveFileFromTerminal(form.PcFilename,form.DownloadType,form.TerminalFilename,form.TerminalDrive,form.ContinueWhenNotAvailable)) Then
                listOptions.Items.Add("Send file from Terminal To PC")
            Else
                MessageBox.Show("Error in settings to receive file from Terminal", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If

        End If
    End Sub

    Private Sub buttonPCToTerminal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonPCToTerminal.Click
        Dim Form As FileForm = New FileForm
        Form.FormText = "Send File From PC to Terminal"
        If (Form.ShowDialog() = DialogResult.OK) Then
            If (OseComm1.AddTransmitFileToTerminal(Form.PcFilename, Form.TerminalFilename, Form.TerminalDrive, Form.ContinueWhenNotAvailable)) Then
                listOptions.Items.Add("Send file from PC to Terminal")
            Else
                MessageBox.Show("Error in settings to send file to Terminal", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub buttonListFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonListFiles.Click
        Dim form As QueryForm = New QueryForm()
        form.FormText = "List Files"
        form.TerminalFilename = "*.*"
        If (form.ShowDialog() = DialogResult.OK) Then
            If (OseComm1.AddGetTerminalFileList(form.TerminalFilename, form.TerminalDrive)) Then
                listOptions.Items.Add("List files")
            Else
                MessageBox.Show("Error in settings for List Files", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub buttonDeleteFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonDeleteFiles.Click
        Dim form As QueryForm = New QueryForm()
        form.FormText = "Delete Files"
        form.TerminalFilename = "*.*"
        If (form.ShowDialog() = DialogResult.OK) Then
            If (OseComm1.AddDeleteTerminalFiles(form.TerminalFilename, form.TerminalDrive)) Then
                listOptions.Items.Add("Delete files")
            Else
                MessageBox.Show("Error in settings for List Files", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub buttonClearLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonClearLog.Click
        listStatus.Items.Clear()
    End Sub

    Private Sub OseComm1_Connected(ByVal sender As System.Object, ByVal e As Opticon.ConnectedEventArgs) Handles OseComm1.Connected
        listStatus.Items.Insert(0, String.Format("Connected to ID: {0}", e.TerminalID))
    End Sub

    Private Sub OseComm1_Progress(ByVal sender As System.Object, ByVal e As Opticon.ProgressEventArgs) Handles OseComm1.Progress
        progressFileTransfer.Value = e.Progress
    End Sub

    Private Sub OseComm1_StatusInformation(ByVal sender As System.Object, ByVal e As Opticon.StatusInformationEventArgs) Handles OseComm1.StatusInformation
        If (CType(e.Status, OseComm.StatusCodes) = OseComm.StatusCodes.ERR_COMPORT_ERROR) Then
            MessageBox.Show("COM port could not be opened or is no longer available", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        listStatus.Items.Insert(0, e.Information)
    End Sub
End Class
